#define MAX_STROKES_LEN	51
#include "GBK2strokes.h"

// compare two GBK strings by Unicode codes
// Note: this function returns 0 for invalid GBK strings!
int strcmp_strokes_GBK(char *string1, char *string2)
{
	int i1, i2;
	while(*string1!='\0' && *string2!='\0')
	{
		i1 = cstr2i(string1);
		i2 = cstr2i(string2);
		if(i1==-1 || i2==-1) return 0;
		if(bSort == SORT_BY_STROKES_O) // ˳
			rtn = strcmp(GBK_strokes[i1], GBK_strokes[i2]);
		else // if(bSort == SORT_BY_STROKES_N) // ʻ+˳
		{
			rtn = strlen(GBK_strokes[i1])-strlen(GBK_strokes[i2]);
			if(rtn == 0) rtn = strcmp(GBK_strokes[i1], GBK_strokes[i2]);
		}
		if(rtn) return rtn;
		string1 += 2; string2 += 2;
	}
	if(*string1 != '\0') return 1; // strlen(string1) > strlen(string2)
	if(*string2 != '\0') return -1; // strlen(string1) < strlen(string2)
	return 0; // strlen(string1) = strlen(string2)
}
// compare two strings by Unicode
int strcmp_strokes(char *string1, char *string2, int index1, int index2)
{
	unsigned char bGBK1 = 1, bGBK2 = 1;
	int rtn;
	char *p1, *p2;
	while(*string1!='\0' && *string2!='\0')
	{
		bGBK1 = IsGBKChar(string1);
		bGBK2 = IsGBKChar(string2);
		if((bGBK1 && bGBK2) || (!bGBK1 && !bGBK2))// two GBK pinyin (or two non-GBK) strings
		{
			p1 = strchr(string1, SEPARATOR_IN_NAME);
			if(p1) *p1 = '\0';
			p2 = strchr(string2, SEPARATOR_IN_NAME);
			if(p2) *p2 = '\0';
			if(bGBK1 && bGBK2) rtn = strcmp_strokes_GBK(string1, string2);
			else // !bGBK1 && !bGBK2
			{
				if(stricmp(string1, string2)) // only return when string /neq string2
				{
					if(index1 > index2) rtn = 1;
					else if(index1 < index2) rtn = -1;
					else rtn = 0;
				}
				else rtn = 0;
			}
			if(p1) *p1 = SEPARATOR_IN_NAME;
			if(p2) *p2 = SEPARATOR_IN_NAME; // restore the strings before returning
			if(rtn) return rtn;
			if(p1) string1 = p1+1;
			else string1 += strlen(string1); // end of string1
			if(p2) string2 = p2+1;
			else string2 += strlen(string2); // end of string2
		}
		else if(bGBK1) // && !bGBK2
		{
			switch(bGBK2NonGBK)
			{
			case GBK_LESS_NON_GBK: return -1;
			// case NON_GBK_LESS_GBK:
			default: return 1;
			}
		}
		else // bGBK2 && !bGBK1
		{
			switch(bGBK2NonGBK)
			{
			case GBK_LESS_NON_GBK: return 1;
			// case NON_GBK_LESS_GBK:
			default: return -1;
			}
		}
	}
	if(*string1 != '\0') return 1;
	if(*string2 != '\0') return -1;
	return 0;
}
int strcmp_strokes_Authors(char *szAuthors1, char *szAuthors2, int index1, int index2)
{
	int rtn;
	while(*szAuthors1!='\0' && *szAuthors1!='\0')
	{
		rtn = strcmp_strokes(szAuthors1, szAuthors2, index1, index2);
		if(rtn != 0) return rtn;
		szAuthors1 += strlen(szAuthors1)+1;
		szAuthors2 += strlen(szAuthors2)+1;
	}
	if(*szAuthors1 != '\0') return 1;
	if(*szAuthors2 != '\0') return -1;
	return 0;
}
