#define PINYIN_MAX				10 // " gong1fen1 gong1fen1"
#define LINE_MAX				256
#define LINE_MAX2				512
#define AUTHORS_MAX				3840 // PINYIN_MAX*15
#define GBK_CODES_NUMBER		23940
#define NAME_SEPARATOR			'\0'
// An invisible character should be used.
// Any visible one may be used in the authors list, such as "Yahoo!" and "C# Committee".
#define SEPARATOR_IN_NAME		'\a'
//#define ENGLISH_PREFIX			'\t'

// ±ڱȥ˿ͷ" "","ַEditor(s)ԭʼӢַ
char	str_Editors2Char_short[MAX_CHAR_LENGTH] = "editors";//EditorԭʼӢִ()
char	str_Editor2Char_short[MAX_CHAR_LENGTH] = "editors";//EditorԭʼӢִ()

// the following are flags for comparing a GBK character and a non-GBK character
#define GBK_LESS_NON_GBK		1 // GBK string < Non-GBK string
#define NON_GBK_LESS_GBK		2 // Non-GBK string < GBK string
unsigned char bGBK2NonGBK = GBK_LESS_NON_GBK;
// the following are falgs for comparing two Non-GBK authors
// fixbblӦӢΪӢдڴĸ\"{A}{\OE}ȡ
// ޸Ĵ룺
// 1) ӦӢƬβͬʱindexȷ
// 2) ӦӢƬͬʱȽһƬΡ
#define FIRST_LESS_SECOND			0 // index1 < index2 => string1 < string2
#define SECOND_LESS_FIRST			1 // index1 < index2 => string1 > string2
#define LESS_BY_STRCMP				2 // strcmp(string1, string2)
unsigned char bNonGBK2NonGBK = FIRST_LESS_SECOND;

#define GBKperLB				190
//һbytesʾGBKתΪ0-
__inline int cbytes2i(BYTE bHigh, BYTE bLow)
{
	if(bHigh < 0x81 || bHigh == 0xFF) return -1;
	if(bLow < 0x40 || bLow == 0xFF || bLow == 0x7F) return -1;
	if(bLow < 0x7F) return (bHigh - 0x81) * GBKperLB + (bLow - 0x40);
	else return (bHigh - 0x81) * GBKperLB + (bLow - 0x40 - 1);
}
//һ˫ַGBKתΪ0-
int cstr2i(char *cstr)
{
	BYTE bHigh, bLow;
	bHigh = (BYTE) cstr[0];
	bLow = (BYTE) cstr[1];
	return cbytes2i(bHigh, bLow);
}
void i2cstr(int i, char *cstr)
{
	BYTE bHigh, bLow;
	bHigh = i / GBKperLB + 0x81;
	bLow = i % GBKperLB + 0x40;
	if( bLow >= 0x7F) bLow ++;
	cstr[0] = (char) bHigh;
	cstr[1] = (char) bLow;
}

__inline int IsGBKChar(char *str)
{
	if(str[0] == '\0') return 0; // str[1] is valid only when str[0] != '\0'...
	return (GBK_HIGH(str[0]) && GBK_LOW(str[1]));
}

// Tranform the authors list to multiple interlaced authors lists,
//  each of which corresponds to one author.
// An example of author: "{\'{A}lvarez and Li Foundation, Inc. (Spain)}".
// The brackets are not processed in this function.
void Authors2Authors(char *szAuthorsDest, char *strAuthorsSour)
{
	char *strTempDest, *strTempSour;
	int word_count = 0, comma_count = 0, bracket_count = 0; //, all_bracket_count = 0;
	unsigned char bValidWord = 0, bHasSpaceComma;
	strTempDest = szAuthorsDest;
	strTempSour = strAuthorsSour;
	while(*strTempSour != '\0')
	{
		// replace all '~', '\n', '\r' by ' ' to simplify the following codes
		if(*strTempSour=='~' || *strTempSour=='\n' || *strTempSour=='\r') *strTempSour = ' ';
		*strTempSour++;
	}
	strTempSour = strAuthorsSour;
	while(*strTempSour!='\0')
	{
		if(*strTempSour==' ' || *strTempSour==',')
		{
			bHasSpaceComma = 1;
			do
			{
				strTempSour++; // skip leading spaces
			}while(*strTempSour==' ' || *strTempSour==',');
		}
		else bHasSpaceComma = 0;

		if(*strTempSour=='\0' || *strTempSour=='\n' || *strTempSour=='\r') break; // end of authors list
		if(bracket_count == 0)
		{
			// if(*strTempSour == '.') break; // end of authors list
			if(!strnicmp(strTempSour, "et al", 5)) break; // end of authors list
			if(!strnicmp(strTempSour, "et~al", 5)) break; // end of authors list
			if(!strnicmp(strTempSour, str_Editors2Char_short, strlen(str_Editors2Char_short))) break; // end of editors list
			if(!strnicmp(strTempSour, str_Editor2Char_short, strlen(str_Editor2Char_short))) break; // end of editors list
			if((*strTempSour=='(' || *strTempSour=='[') && isdigit(strTempSour[1])) break; // end of authors list, before [year] or (year)
		}

		bValidWord = 1;
		if(*strTempSour == '{')
		{
			*strTempDest++ = '{'; strTempSour++; bracket_count++; continue;
		}
		else if(*strTempSour == '}')
		{
			*strTempDest++ = '}'; strTempSour++; bracket_count--;
			goto check_space_comma;
		}
		else if(*strTempSour == '(')
		{
			while(*strTempSour!=')' && *strTempSour!='\0') *strTempDest++ = *strTempSour++;
			if(*strTempSour == ')')
			{
				*strTempDest++ = ')'; strTempSour++;
			}
			bValidWord = 0;
			goto check_space_comma;
		}
		else if(*strTempSour == '\\')
		{
			*strTempDest++ = *strTempSour++;
			if(*strTempSour=='{' || *strTempSour=='}') *strTempDest++ = *strTempSour++;
		}
		else if(!IsGBKChar(strTempSour)) // copy one GBK character
		{
			*strTempDest++ = *strTempSour++; // copy one non-trivial character
			if(IsGBKChar(strTempSour)) word_count++;
		}
		else
		{
			*strTempDest++ = *strTempSour++;
			*strTempDest++ = *strTempSour++;
			if(*strTempSour!=' ' && *strTempSour!=',') word_count++;
			if(bSort!=SORT_BY_PINYIN && !strnicmp(strTempSour, "\\pinyin{", 8))
			{
				// if not sorted by pinyin, skip this command
				strTempSour += 8;
				while(*strTempSour!='}' && *strTempSour!='\0') strTempSour++;
			}
			else if(*strTempSour == '.') break; // "." ends the current author
		}

check_space_comma:
		if(*strTempSour == ',')
		{
			strTempSour++; comma_count++;
			if(bValidWord) word_count++;
			if(bracket_count || comma_count==0 || word_count<2)
			{
				*strTempDest++ = ',';
				if(*strTempSour == ' ')
				{
					*strTempDest++ = ' '; strTempSour++;
				}
			}
		}
		else if(*strTempSour == ' ')
		{
			strTempSour++;
			if(bValidWord) word_count++;
			if(bracket_count || comma_count==0 || word_count<2) *strTempDest++ = ' ';
		}
		if(bracket_count == 0)
		{
			while(*strTempSour==' ' || *strTempSour==',') strTempSour++; // skip more spaces and commas
			if(!strnicmp(strTempSour, "and ", 4))
			{
				strTempSour += 4;
				comma_count++;
				if(bValidWord) word_count++;
				if(strTempDest[-1] == ' ') strTempDest--;
			}
			if(!strnicmp(strTempSour, "\\& ", 3))
			{
				strTempSour += 3;
				comma_count++;
				if(bValidWord) word_count++;
				if(strTempDest[-1] == ' ') strTempDest--;
			}
			if(comma_count>0 && word_count>=2) // end of the current author
			{
				word_count = comma_count = 0;
				*strTempDest++ = '\0';
			}
		}
	}
	if(word_count) *strTempDest++ = '\0'; // if the last author does not end with '\0'
	*strTempDest = '\0'; // add an additional '\0' at the end
}

// Transform a string into some segments containing continuous GBK or non-GBK characters.
// One segment cannot contain more than one words (i.e., ' ' and ',' are included in a segment).
// This means "John Jane" = "John, Jane".
void String2Segments(char *szDest, char *szSour)
{
	char bLastGBK = -1, bGBK; // 1 = GBK, 0 = non-GBK, -1 = N/A
	unsigned char bSeparatorAdded = 0;
	int len;
	while(*szSour=='{' || *szSour==' ' || *szSour==',') szSour++; // skip continuous spaces
	len = strlen(szSour);
	if(szSour[len] == '}') szSour[len] = '\0'; // remove the last '}' (if any)
	while(*szSour != '\0')
	{
		if(*szSour==' ' || *szSour==',')
		{
			while(*szSour==' ' || *szSour==',') szSour++; // skip continuous spaces
			if(*szSour == '\0') break;
			*szDest++ = SEPARATOR_IN_NAME;
			bSeparatorAdded = 1;
		}
		else bSeparatorAdded = 0;

		bGBK = IsGBKChar(szSour);
		if(bLastGBK!=-1 && bSeparatorAdded==0)
		{
			if(bSort==SORT_BY_PINYIN && bGBK) *szDest++ = SEPARATOR_IN_NAME;
			else if(bGBK != bLastGBK) *szDest++ = SEPARATOR_IN_NAME;
		}
		bLastGBK = bGBK;
		if(bGBK)
		{
			*szDest++ = *szSour++;
			*szDest++ = *szSour++;
		}
		else *szDest++ = *szSour++;
	}
	*szDest = '\0';
}

void String2Py(char *szPy, char *szGBK);

// Transform a string into some segments containing continuous GBK or non-GBK characters.
void Authors2Segments(char *szAuthorsSegment, char *szAuthorsSour)
{
	if(bSort == SORT_BY_PINYIN)
	{
		while(*szAuthorsSour != '\0')
		{
			String2Py(szAuthorsSegment, szAuthorsSour);
			szAuthorsSour += strlen(szAuthorsSour)+1;
			szAuthorsSegment += strlen(szAuthorsSegment)+1;
		}
	}
	else
	{
		while(*szAuthorsSour != '\0')
		{
			String2Segments(szAuthorsSegment, szAuthorsSour);
			szAuthorsSour += strlen(szAuthorsSour)+1;
			szAuthorsSegment += strlen(szAuthorsSegment)+1;
		}
	}
	*szAuthorsSegment = '\0';
}

char __szTemp[LINE_MAX2+1];
void ProcessAuthors(char *szAuthorsDest, char *strAuthorsSour)
{
	Authors2Authors(__szTemp, strAuthorsSour);
	Authors2Segments(szAuthorsDest, __szTemp);
}
